<?php
/**
 * Debit API Demo - logic file
 * version 1.0
 * 
 * author: Thorsten Kugler 
 * email: tkugler@micropayment.de
 * supported 2009 by micropayment
 */

	require_once( 'config.php' );
	require_once( 'tools.php' );
	require_once( './lib/init.php' );
	require_once( './lib/services/' . MCP__DEBITSERVICE_INTERFACE . '.php' );
	require_once( MCP__SERVICELIB_DISPATCHER . 'TNvpServiceDispatcher.php');    

	$errorMsg = '';
	if (getPostVar('action') != "") {$action = getPostVar('action');}
	elseif (getGetVar('action') != "") {$action = getGetVar('action');};
	

//---------------------------------------------------------------------
//guest status
	if ($action == 'login_guest') {	
		
		session_name('debit');
		session_start();
		
		//vars for login page navigation
		$_SESSION['radio'] = 'radio3'; $_SESSION['customer_type'] = 'guest';	
			
		//no products available
		if (count($_SESSION['products']) == 0) {
			getTemplate('page.login.html', 'radio', $_SESSION['radio'], 'customer_type', $_SESSION['customer_type'], 'error_msg', '<br />Als Gast-Besteller m&uuml;ssen Produkte vorhanden sein. <a href="debit_demo.php">Hier gelangen Sie zu unserem Shop</a>', 'status', 'statusError'); exit(0);
		}
		
		//save form data
		if (getPostVar('status') == "saveData") {
			
			try {
				//create customer, set address data, set contact data, set bankacocunt data
				$customerData = $dispatcher -> customerCreate(MCP__ACCESSKEY, MCP__TESTMODE, null, null);
				$_SESSION["customerId"] = $customerData['customerId'];
						
				$addressData = $dispatcher -> addressSet(MCP__ACCESSKEY, MCP__TESTMODE, $_SESSION["customerId"], getPostVar('firstName'), getPostVar('surName'), getPostVar('street'), getPostVar('zip'), getPostVar('city'), getPostVar('country2'));
				$contactData = $dispatcher -> contactDataSet(MCP__ACCESSKEY, MCP__TESTMODE, $_SESSION["customerId"], getPostVar('email'), getPostVar('phone'), getPostVar('mobile'));
				$bankaccountData = $dispatcher -> bankaccountSet(MCP__ACCESSKEY, MCP__TESTMODE, $_SESSION["customerId"], getPostVar('country2'), getPostVar('bankCode'), getPostVar('accountNumber'), getPostVar('accountHolder'));
			}
			catch (Exception $e) {
				getTemplate('page.guest.html', 'firstName', getPostVar('firstName'), 'surName', getPostVar('surName'), 'street', getPostVar('street'), 'zip', getPostVar('zip'), 'city', getPostVar('city'), 'country', getPostVar('country2'), 'email', getPostVar('email'), 'phone', getPostVar('phone'), 'mobile', getPostVar('mobile'), 'bankCode', getPostVar('bankCode'), 'accountNumber', getPostVar('accountNumber'), 'accountHolder', getPostVar('accountHolder'), 'status', 'statusError', 'error_msg', $e->getMessage()); 
				exit(0);
			}
			
			//all data saved successfully
			header("Location: ./debit_demo.php?action=shoppingTmp"); 
			exit(0);
		}

		//set guest status
		
		getTemplate('page.guest.html', 'firstName', '', 'surName', '', 'street', '', 'zip', '', 'city', '', 'country', '',  'email', '', 'phone', '', 'mobile', '', 'bankCode', '', 'accountNumber', '', 'accountHolder', '', 'error_msg', '', 'statusError', ''); 
		exit(0);
	}
//---------------------------------------------------------------------

//---------------------------------------------------------------------
	if ($action == 'login_user') {	

		session_name('debit');
		session_start();
		
		//vars for login page navigation
		$_SESSION['radio'] = 'radio'; $_SESSION['customer_type'] = 'known';
		
		try {
			$customerData = array();
			$customerData = $dispatcher -> customerGet(MCP__ACCESSKEY, MCP__TESTMODE, getPostVar('customerId'));
		}
		catch (Exception $e) {
			$error_msg = "User existiert nicht";
		}
		//check password with password in freeParams
		if ($customerData['freeParams']['password'] != getPostVar('password')) {
			$error_msg = "Username oder Passwort sind ung&uuml;ltig"; 
		}

		//show error message
		if (isset($error_msg)) {
			getTemplate('page.login.html', 'customer_type', $_SESSION['customer_type'], 'radio', $_SESSION['radio'], 'error_msg', 'Username oder Passwort sind ung&uuml;ltig', 'status', 'statusError');
			exit(0);
		}
		
		$_SESSION["customerId"] = getPostVar('customerId');
		
		// check registerstatus and redirect
		switch ($customerData['freeParams']['status']) {
			// user needs to fill all the forms
			case '': header("Location: ./debit_demo.php?action=address"); exit(0);
			// user has filled his address
			case 'addresscomplete': header("Location: ./debit_demo.php?action=contact"); exit(0);
			// user has filled his contactdata
			case 'contactcomplete': header("Location: ./debit_demo.php?action=bankaccount"); exit(0);
			// user has filled all forms
			case 'allcomplete': header("Location: ./debit_demo.php?action=shoppingTmp"); exit(0);
		}
	}
//---------------------------------------------------------------------

//---------------------------------------------------------------------
	//login-page, NOT login_user!
	if ($action == 'login') {
	
		session_name('debit');
		session_start();
		
		//set default for login page navigation
		if ($_SESSION['radio'] == "") { $_SESSION['radio'] = 'radio'; };
		if ($_SESSION['customer_type'] == "") { $_SESSION['customer_type'] = 'known'; };

		//set product session array
		if(getPostVar('products') != "") {
			foreach (getPostVar('products') as $product) {
				$_SESSION["products"][$product] += 1;
			}
		}
		
		//without login procedure if customer is logged in yet
    	if (isset($_SESSION["customerId"])) { // && ($_SESSION["guest"] != '1')) {
			header("Location: ./debit_demo.php?action=shoppingTmp");
			exit(0);
		}

		//show login page
		getTemplate('page.login.html', 'radio', $_SESSION['radio'], 'customer_type', $_SESSION['customer_type'], 'error_msg', $_GET['errorMsg']); 
		exit(0);
	}
//---------------------------------------------------------------------

//---------------------------------------------------------------------
	if ($action == 'register') {
		
		session_name('debit');
		session_start();
		
		//vars for login page navigation
		$_SESSION['radio'] = 'radio2'; $_SESSION['customer_type'] = 'new';
		
		//check passwords
		if (!(getPostVar('password') == getPostVar('password2')) || (getPostVar('password') == "") || !(strlen(getPostVar('password')) >= MIN_PASSWD_LENGTH)) {
			$error_msg = "Passw&ouml;rter stimmen nicht &uuml;berein";
			getTemplate('page.login.html', 'customer_type', $_SESSION['customer_type'], 'radio', $_SESSION['radio'], 'error_msg', $error_msg, 'status', 'statusError'); 
			exit(0);
		}

		$freeParams = array(
			'password' => getPostVar('password'),
			'status' => ''
		);
		
		$customerData = array();
		try {
			$customerData = $dispatcher -> customerCreate(MCP__ACCESSKEY, MCP__TESTMODE, getPostVar('customerId'), $freeParams);
		}
		catch (Exception $e) {
			$error_msg = "User existiert bereits, bitte w&auml;hlen Sie einen anderen Usernamen";
			getTemplate('page.login.html', 'customer_type', $_SESSION['customer_type'], 'radio', $_SESSION['radio'], 'error_msg', $error_msg, 'status', 'statusError'); 
			exit(0);
		}		

		$_SESSION["customerId"] = getPostVar('customerId');
		getTemplate('page.address.html', 'firstName', '', 'surName', '', 'street', '', 'zip', '', 'city', '', 'country', '', 'error_msg', ''); 
		exit(0);
	}
//---------------------------------------------------------------------

//---------------------------------------------------------------------
//	if ($action == 'deleteProduct') {
//		session_name('debit');
//		session_start();
//	
//		$_SESSION['products'][getPostVar('product')] --;
//		if ($_SESSION['products'][getPostVar('product')] == 0) {
//			unset($_SESSION['products'][getPostVar('product')]);
//		}
//		header("Location: ./debit_demo.php?action=shoppingTmp");
//		exit(0);
//}
//---------------------------------------------------------------------

//---------------------------------------------------------------------
	if ($action == 'reCalc') {
		
		session_name('debit');
		session_start();
		
		$_SESSION['amount'] = 0;
		$aCount = getPostVar('count'); //array reached from form
		$aProducts = getPostVar('product'); //array reached from form

		$c = 0;
		foreach ($aProducts as $product) {
			//check if count is >0 AND is number
			if (($aCount[$c] >= 0) && (preg_match("/^\d*$/", $aCount[$c]))) {
				$_SESSION['products'][$product] = $aCount[$c];
				foreach  ($_SESSION['products'] as $product => $count) {
					//calculate amount
					$_SESSION['amount'] +=  ($aProductList[$product]['amount'] * $count);
				}
			}
			$c += 1;
		}
		
		//back to calling script
		header("Location: ".$_SERVER['HTTP_REFERER']);
		exit(0);
	}
//---------------------------------------------------------------------

//---------------------------------------------------------------------
	if ($action == 'resetTest') {
		
		session_name('debit');
		session_start();
		
		try {
			$resetData = $dispatcher -> resetTest(MCP__ACCESSKEY, MCP__TESTMODE);
			
			session_unset();
			session_destroy(); 

			getTemplate('page.login.html', 'customer_type', 'known', 'radio', 'radio', 'error_msg', 'Testumgebung erfolgreich zur&uuml;ckgesetzt!<br><a href="./debit_demo.php">Hier kommen Sie zu unserem Shop</a>', 'status', 'statusError'); 
			exit(0);
		} 
		catch (Exception $e) {
			getTemplate('page.login.html', 'customer_type', 'known', 'radio', 'radio', 'error_msg', 'Testumgebung nicht erfolgreich zur&uuml;ckgesetzt:<br />', 'status', 'statusError'); 
			exit(0);
		}
	}
//---------------------------------------------------------------------

//---------------------------------------------------------------------
	if ($action == 'reversal') {

		try {
			$reversalData = $dispatcher -> sessionReverseTest(MCP__ACCESSKEY, MCP__TESTMODE, getPostVar('sessionId'));
			print header ("Location: debit_demo.php?action=shoppingFin&status=statusSuccess&error_msg=Der Einkauf wurde erfolgreich storniert!");
			exit(0);
		} 
		catch (Exception $e) {
			print header ("Location: debit_demo.php?action=shoppingFin&status=statusError&error_msg=Der Einkauf konnte nicht storniert werden:<br />".$e->getMessage());
			exit(0);
		}
	}
//---------------------------------------------------------------------

//---------------------------------------------------------------------
	if ($action == 'address') {
		
		session_name('debit');
		session_start();
		
		$adressData = array();
		
		try {
			$addressData = $dispatcher -> addressGet(MCP__ACCESSKEY, MCP__TESTMODE, $_SESSION["customerId"]);
			$status = '';
			$statusImg = '';
			$error_msg = '';
		}
		catch (Exception $e) {
			$status = 'statusError';
			$statusImg = './img/error.gif';
			$error_msg = 'Daten konnten nicht gelesen werden.';
		}

		getTemplate('page.address.html', 'firstName', $addressData['firstName'], 'surName', $addressData['surName'], 'street', $addressData['street'], 'zip', $addressData['zip'], 'city', $addressData['city'], 'country', $addressData['country'], 'statusStyle', $status, 'statusImg', $statusImg, 'error_msg', $error_msg);
		exit(0);
	}
//---------------------------------------------------------------------

//---------------------------------------------------------------------
	if ($action == 'addressSet') {
		
		session_name('debit');
		session_start();
	
		try {
			$addressData = $dispatcher -> addressSet(MCP__ACCESSKEY, MCP__TESTMODE, $_SESSION["customerId"], getPostVar('firstName'), getPostVar('surName'), getPostVar('street'), getPostVar('zip'), getPostVar('city'), getPostVar('country'));
		
			$freeParams = array(
				'status' => 'addresscomplete'
			);
			
			$customerData = $dispatcher -> customerSet(MCP__ACCESSKEY, MCP__TESTMODE, $_SESSION["customerId"], $freeParams);
			$status = 'statusSuccess';
			$statusImg = './img/success.gif';
			$error_msg = 'Erfolgreich gespeichert<br /><a href="debit_demo.php?action=contact">Weiter mit <em>Kontaktdaten eingeben</em></a>';
		} 
		catch (Exception $e) {
			$status = 'statusError';
			$statusImg = './img/error.gif';
			$error_msg = 'Daten konnten nicht gespeichert werden'. ':<br>'.$e->getMessage();
		}
		
		getTemplate('page.status.html', 'statusStyle', $status, 'statusImg', $statusImg, 'statusMsg', $error_msg); 
		exit(0);
	}
//---------------------------------------------------------------------

//---------------------------------------------------------------------
	if ($action == 'contact') {
	
		session_name('debit');
		session_start();

		try {
			$contactData = $dispatcher -> contactDataGet(MCP__ACCESSKEY, MCP__TESTMODE, $_SESSION["customerId"]);
			$status = '';
			$statusImg = '';
			$error_msg = '';
		}
		catch (Exception $e) {
			$status = 'statusError';
			$statusImg = './img/error.gif';
			$error_msg = 'Daten konnten nicht gelesen werden.';
		}
		
		getTemplate('page.contact.html', 'email', $contactData['email'], 'phone', $contactData['phone'], 'mobile', $contactData['mobile'], 'statusStyle', $status, 'statusImg', $statusImg, 'error_msg', $error_msg); 
		exit(0); 
		
	
	}
//---------------------------------------------------------------------

//---------------------------------------------------------------------
	if ($action == 'contactSet') {

		session_name('debit');
		session_start();
	
		try {
			$contactData = $dispatcher -> contactDataSet(MCP__ACCESSKEY, MCP__TESTMODE, $_SESSION["customerId"], getPostVar('email'), getPostVar('phone'), getPostVar('mobile'));
			
			$freeParams = array(
				'status' => 'contactcomplete'
			);
			
			$customerData = $dispatcher -> customerSet(MCP__ACCESSKEY, MCP__TESTMODE, $_SESSION["customerId"], $freeParams);
			
			$status = 'statusSuccess';
			$statusImg = './img/success.gif';
			$error_msg = 'Erfolgreich gespeichert'. '<br /><a href="debit_demo.php?action=bankaccount">Weiter mit <em>Bankdaten eingeben</em></a>';
		} 
		catch (Exception $e) {
			$status = 'statusError';
			$statusImg = './img/error.gif';
			$error_msg = 'Daten konnten nicht gespeichert werden'. ':<br>'.$e->getMessage();
		}
		
		getTemplate('page.status.html',  'statusStyle', 'statusSuccess', 'statusImg', './img/success.gif', 'statusMsg', $error_msg); 
		exit(0);
	}
//---------------------------------------------------------------------

//---------------------------------------------------------------------
	if ($action == 'bankaccount') {
	
		session_name('debit');
		session_start();

		try {
			$bankaccountData = $dispatcher -> bankaccountGet(MCP__ACCESSKEY, MCP__TESTMODE, $_SESSION["customerId"]);
			$status = '';
			$statusImg = '';
			$error_msg = '';
		}
		catch(Exception $e){
			$status = 'statusError';
			$statusImg = './img/error.gif';
			$error_msg = 'Daten konnten nicht gelesen werden.';
		}

		getTemplate('page.bankaccount.html', 'bankCode', $bankaccountData['bankCode'], 'accountNumber', $bankaccountData['accountNumber'], 'accountHolder', $bankaccountData['accountHolder'], 'statusStyle', $status, 'statusImg', $statusImg, 'error_msg', $error_msg); 
		exit(0);
	}
//---------------------------------------------------------------------

//---------------------------------------------------------------------
	if ($action == 'bankaccountSet') {
	
		session_name('debit');
		session_start();
	
		try {
			$bankaccountData = $dispatcher -> bankaccountSet(MCP__ACCESSKEY, MCP__TESTMODE, getPostVar('customerId'), getPostVar('country'), getPostVar('bankCode'), getPostVar('accountNumber'), getPostVar('accountHolder'));
			//reactivate barred account
			//$dispatcher -> bankaccountBar(MCP__ACCESSKEY, MCP__TESTMODE, getPostVar('country'), getPostVar('bankCode'), getPostVar('accountNumber'), 'ALLOWED');
		
			$freeParams = array(
				'status' => 'allcomplete'
			);
			$customerData = $dispatcher -> customerSet(MCP__ACCESSKEY, MCP__TESTMODE, $_SESSION["customerId"], $freeParams);
			
			$status = "statusSuccess";
			$statusImg = "./img/success.gif";
			$error_msg = "Ermittelte Bank ist: ".$bankaccountData['bankName']."<br />".'Erfolgreich gespeichert'. "<br /><br /><a href='debit_demo.php?action=shoppingTmp'>Weiter mit <em>Buchungs-Zusammenfassung</em></a>";
			
			print '<SCRIPT language="JavaScript">window.location="./debit_demo.php?action=shoppingTmp";</SCRIPT>';
			exit(0);
			
		} 
		catch (Exception $e) {
			$status = 'statusError';
			$statusImg = './img/error.gif';
			$error_msg = 'Daten konnten nicht gespeichert werden'. ':<br>'.$e->getMessage();
		}
		
		getTemplate('page.status.html',  'statusStyle', 'statusSuccess', 'statusImg', './img/success.gif', 'statusMsg', $error_msg); 
		exit(0);
	}
//---------------------------------------------------------------------

//---------------------------------------------------------------------
	if ($action == 'approve') {
	
		session_name('debit');
		session_start();
	
		//nothing to approve
		if (count($_SESSION["products"]) == 0 || ($_SESSION['amount'] == 0)) {
			header("Location: ./debit_demo.php?action=shoppingTmp");
			exit(0);
		}
	
		//set product array to freeParams
		$freeParams = array(
			'products' => $_SESSION["products"]
		);

		$iProductsAmount = 0;
		foreach ($_SESSION["products"] as $product => $count) {
    		$iProductsAmount += (($aProductList[$product][amount]) / 100) * $count;
    	}
		
		try {
			$sessionData = $dispatcher -> sessionCreate(MCP__ACCESSKEY, MCP__TESTMODE, $_SESSION["customerId"], null, PROJECT_NAME, '', '', '', ($iProductsAmount*100), PROJECT_CURRENCY, PROJECT_TITLE, PAY_TEXT, getenv("REMOTE_ADDR"), $freeParams);
			$approveData = $dispatcher -> sessionApprove(MCP__ACCESSKEY, MCP__TESTMODE, $sessionData['sessionId']);
			$chargeData = $dispatcher -> sessionChargeTest(MCP__ACCESSKEY, MCP__TESTMODE);
			
			$sSessionData = ""; 
			foreach ($sessionData as $tmp => $value) {
				$sSessionData .= $tmp. ": ". $value. "<br />";
			}

			//empty shopping list
			$_SESSION['products'] = array();
			$_SESSION['amount'] = 0;
			
		}
		catch(Exception $e) {
			getTemplate('page.approve.html', 'approveData', 'Buchung nicht durchgef&uuml;hrt!', 'sessionData', $sSessionData, 'status', 'statusErrorDiv', 'error_msg', 'Session konnte nicht erzeugt werden'. ':<br />'. $e ->getMessage());
			exit(0);
		}
		
		getTemplate('page.approve.html', 'approveData', 'Buchung war erfolgreich!<br />Buchungs-Zeit'. ": ".$approveData['expire'], 'error_msg', ''); 
		exit(0);
	}
//---------------------------------------------------------------------

//---------------------------------------------------------------------
	if ($action == 'productsbag') { //logged out

		session_name('debit');
		session_start();

	
		
		//products available?
		if ((count($_SESSION['products']) == 0) && ($_SESSION['amount'] == 0)) {
			
			$sContent = '<br />'. 'Keine Produkte vorhanden';
			$error_msg = 'Es sind keine Produkte im Warenkorb!';
			$status = 'statusErrorDiv';
		
		}
		else {    		

			//get amount
			$_SESSION['amount'] = 0;
			foreach  ($_SESSION['products'] as $product => $count) {
				$_SESSION['amount'] +=  ($aProductList[$product]['amount'] * $count);
			}
		
			//set table rows for products
			$sContent = "<br /><table width='100%'>";
			$sContent .= '<form method="POST" action="./debit_demo.php">'; 
				
			//show all products in SESSION
			foreach ($_SESSION['products'] as $product => $count) {
				$sContent .= '<tr>';
				$sContent .= 	'<td width="60" class="productsbought">';
				$sContent .= 		'<img src="./img/'.$product.'.jpg" height="30">';
				$sContent .=	'</td>';
				$sContent .= 	'<td width="150" class="productsbought">'; 
   				$sContent .= 		$aProductList[$product]['title'].'<br />';
   				$sContent .= 	'</td>';
				$sContent .= 	'<td  width="100" class="productsbought">'; 
   				$sContent .= 		formatAmount(($aProductList[$product]['amount']/100)).' '.PROJECT_CURRENCY;
    			$sContent .= 	'</td>';    
   				$sContent .= 	'<td  width="100" class="productsbought">'; 
	   			$sContent .= 		'<input align="absmiddle" style="font-size:9px;width:30px; height:10px;" type="text" name="count[]" id="count[]" value="'.$count.'">' . ' St&uuml;ck';
   				$sContent .= 	'</td>'; 
				$sContent .= 	'<td  width="250" class="productsbought">';
				$sContent .= 		'<input type="hidden" name="action" id="action" value="reCalc">'; 
				$sContent .= 		'<input type="hidden" name="product[]" id="product[]" value="'.$product.'">';
   				$sContent .= 	"</td>";    
   				$sContent .= "</tr>";
			}
   			$sContent .= "</table><hr><br />";
   			
    		//show amount and recalc button
	   		$sContent .= "<table width='100%'>";
   			$sContent .= 	"<tr>";
   			$sContent .= 		'<td width="60">';
	  		$sContent .= 			'<input class="reCalc" type="submit" value="Neu berechnen">';
   			$sContent .= 		"</td>";
   			$sContent .= 		'<td width="150"><b>Gesamtsumme</b>:';
	   		$sContent .= 		"</td>";
   			$sContent .= 		'<td width="100">'.formatAmount($_SESSION['amount'] / 100).' '.PROJECT_CURRENCY;
   			$sContent .= 		"</td>";
   			$sContent .= 		'<td width="100">';
   			$sContent .= 		"</td>";
	   		$sContent .= 		'<td width="250">';
   			$sContent .= 			'<a href="debit_demo.php?action=login"><img src="./img/www.micropayment.de.png" border="0"></a>';
   			$sContent .= 		"</td>";
	   		$sContent .= 	"</tr>";
   			$sContent .= "</table>";
   			
   			$sContent .= "</form>";
   			
			$error_msg = '';
			$status = '';
		}
		
		getTemplate('page.productsbag.html', 'amount', formatAmount($_SESSION['amount'] / 100), 'productsbought', $sContent, 'error_msg', $error_msg, 'status', $status);
		exit(0);  
	}		
//---------------------------------------------------------------------

//---------------------------------------------------------------------
	if ($action == 'shoppingTmp') { //products bag, logged in mode

		session_name('debit');
		session_start();

	    try {
    		$bankaccountData = $dispatcher -> bankaccountGet(MCP__ACCESSKEY, MCP__TESTMODE, $_SESSION["customerId"]);
		} 
		catch (Exception $e) {
			getTemplate('page.bankaccount.html', 'bankCode', '', 'accountNumber', '', 'accountHolder', '', 'error_msg', 'Bankdaten konnten nicht gelesen werden.'); 
			exit(0);
		}

    	//products available?
		if ((count($_SESSION['products']) == 0) && ($_SESSION['amount'] == 0)) {

			$sContent = "<br />Keine Produkte vorhanden!"; 
			$error_msg = 'Es sind keine Produkte im Warenkorb!'; 
			$status = 'statusErrorDiv';
		}
		else {

	    	//set amount
			$_SESSION['amount'] = 0;
			foreach  ($_SESSION['products'] as $product => $count) {
				$_SESSION['amount'] +=  ($aProductList[$product]['amount'] * $count);
			}
		
			//set rows per product
			$sContent = "<br /><table width='100%'>";
			$sContent .= '<form method="POST" action="./debit_demo.php">'; 
			
			//show all products in SESSION
			foreach ($_SESSION['products'] as $product => $count) {
				$sContent .= '<tr>';
				$sContent .= 	'<td width="60" class="productsbought">';
				$sContent .= 		'<img src="./img/'.$product.'.jpg" height="30">';
				$sContent .=	'</td>';
				$sContent .= 	'<td width="150" class="productsbought">'; 
   				$sContent .= 		$aProductList[$product]['title'].'<br />';
   				$sContent .= 	'</td>';
				$sContent .= 	'<td  width="100" class="productsbought">'; 
   				$sContent .= 		formatAmount(($aProductList[$product]['amount']/100)).' '.PROJECT_CURRENCY;
    			$sContent .= 	'</td>';    
   				$sContent .= 	'<td  width="100" class="productsbought">'; 
	   			$sContent .= 		'<input align="absmiddle" style="font-size:9px;width:30px; height:10px;" type="text" name="count[]" id="count[]" value="'.$count.'">' . ' St&uuml;ck';
   				$sContent .= 	'</td>'; 
				$sContent .= 	'<td  width="250" class="productsbought">';
				$sContent .= 		'<input type="hidden" name="action" id="action" value="reCalc">'; 
				$sContent .= 		'<input type="hidden" name="product[]" id="product[]" value="'.$product.'">';
   				$sContent .= 	"</td>";    
   				$sContent .= "</tr>";
			}
   			$sContent .= "</table><hr>";
   			
	    	//show amount and recalc button
   			$sContent .= "<table width='100%'>";
   			$sContent .= 	"<tr>";
	   		$sContent .= 		'<td width="60">';
   			$sContent .= 		"</td>";
   			$sContent .= 		'<td width="150"><b>Gesamtsumme</b>:';
	   		$sContent .= 		"</td>";
   			$sContent .= 		'<td width="100">'.formatAmount($_SESSION['amount'] / 100).' '.PROJECT_CURRENCY;
   			$sContent .= 		"</td>";
	   		$sContent .= 		'<td width="100">';
   			$sContent .= 		"</td>";
   			$sContent .= 		'<td width="250">';
	   		$sContent .= 			'<input class="reCalc" type="submit" value="Neu berechnen">';
   			$sContent .= 		"</td>";
   			$sContent .= 	"</tr>";
	   		$sContent .= "</table>";
   			
   			$sContent .= "</form>";
   			
   			$error_msg = '';
			$status = '';
		}
		
		getTemplate('page.productsbaglogin.html', 'amount', formatAmount($_SESSION['amount'] / 100), 'bankCode', $bankaccountData['bankCode'], 'bankName', $bankaccountData['bankName'], 'accountNumber', $bankaccountData['accountNumber'], 'accountHolder', $bankaccountData['accountHolder'], 'productsbought', $sContent, 'error_msg', $error_msg, 'status', $status);
		exit(0);
	}		
//---------------------------------------------------------------------

//---------------------------------------------------------------------
	if ($action == 'shoppingFin') { //bought products
		
	   	session_name('debit');
		session_start();

    	try {
    		$_SESSION['anchor'] = 0;

    		//find all sessions for active customer
    		$sessionData = $dispatcher -> sessionList(MCP__ACCESSKEY, MCP__TESTMODE, $_SESSION["customerId"]);
			
    		//set newest element to top
	    	krsort($sessionData['sessionIdList']);
    	
    		$sContent .= '<br />';
    	
    		foreach($sessionData['sessionIdList'] as $tmpdata) {
  			
   				$session2Data = $dispatcher -> sessionGet(MCP__ACCESSKEY, MCP__TESTMODE, $tmpdata);
   				
   				//other status indicates not a successful transaction
   				if(('CHARGED' == $session2Data['status']) || ('REVERSED' == $session2Data['status'])){
    			    
   					//indicates reversed or approved elements by css
   					$indStorno = "productsbought";
   				    if ('REVERSED' == $session2Data['status']) { 
   				    	$indStorno="productsbought_storno"; 
   				    };
       				
   					$sContent .= '<form method="POST" action="./debit_demo.php">
   					             	<table width="100%" style="border-bottom:1px dotted #AAAAAA;">
   								 		<input type="hidden" name="sessionId" id="sessionId" value="';
   					$sContent .= $tmpdata;
   					$sContent .='">
   										<input type="hidden" name="action" id="action" value="reversal">
   									<tr>
   								<td  width="150" class="';
    				$sContent .= $indStorno;
  					$sContent .= '">';

  						//set product images and data
   					foreach ($session2Data['freeParams']['products'] as $product => $count) {
  								$sContent .= "<table><tr>";
  								$sContent .= "<td><img align=absmiddle height=\"30\" src=\"./img/".$product.".jpg\"></td>";
  								$sContent .= "<td class=".$indStorno.">Anzahl: ".$count."</td>";
  								$sContent .= "</tr></table>";
  					}
   					$sContent .= '
   								</td>
   								<td width="170" class="';
   					$sContent .= $indStorno;
    				$sContent .= '">';
   					
   					$tmp_date = round ((time() - strtotime($session2Data['expire'])) / 60, 0);
   					
   					//show time only when transaction startet in last 120 minutes
   					if ($tmp_date < 120) {  				
    					$sContent .= "<div id=\"\" class=\"show_minutes\"> vor ".$tmp_date." Minuten</div><br />".$session2Data['title'];
   					}
   					else {
   						$sContent .= $session2Data['title'];
   					}
   					
   					$sContent .= '
   								</td>
   								<td width="70" class="';
    				$sContent .= $indStorno;
   					$sContent .= '">';
   					$sContent .= formatAmount(($session2Data['amount']/100))." ".$session2Data['currency'];
   					$sContent .= '
								</td>
   								<td class="';
    				$sContent .= $indStorno;
   					$sContent .= '">';
					$sContent .= $sTmp;
    				
					//indicates reversed sessions by css
					if ('REVERSED' != $session2Data['status']) {
						$sContent .= '<input class="storno" type="submit" value="Stornieren"> *';
					}
					else {
						$sContent .= "Storno-timestamp:<br />".$session2Data['expire'];
					}
				
    				$sContent .= '
	    						</td>
	    					</tr>';
	        	}
    			$sContent .= "</table></form>";
    			
    			$error_msg = '';
				$status = '';
    		}
	    }
	    catch (Exception $e) {
    		$sContent = 'Keine Eink&auml;ufe vorhanden!';
    		$error_msg = 'Es sind keine Eink&auml;ufe vorhanden!';
			$status = 'statusErrorDiv';
    	}

		getTemplate('page.productsbought.html', 'productsbought', $sContent, 'error_msg', $error_msg, 'status', $status);
		exit(0);
	}
//---------------------------------------------------------------------

//---------------------------------------------------------------------
	if ($action == 'showAdminTools') {
		
		session_name('debit');
		session_start();
		
		//count anchor, show max SHOW_CUSTOMER (Example 10) customers per request
		$_SESSION['anchor'] += getPostVar('anchor');
		$showCustomer = SHOW_CUSTOMER;
    	
    	try {
    		//list all customers for ACCESS_KEY
    		$customerListData = $dispatcher -> customerList(MCP__ACCESSKEY, MCP__TESTMODE, $_SESSION['anchor'], SHOW_CUSTOMER);
    		
    		//title bar
   			$sAllCustomers = "<div id='allCustomers'>
   								<table width='100%'>
   									<tr>
   										<td class='naviSub'><b>Alle Customer anzeigen</b> (". $customerListData['maxCount'].")
   										</td>
   									</tr>
   								</table>
   								<br /><br />";
    		//title row
			$sAllCustomers .= "<table width=100%>
								<tr>
									<td class=productsbought><b>customerId</b>
									</td>
									<td class=productsbought>
										<b>product</b>
									</td>
									<td class=productsbought><b>total amount:</b>
									</td>
								</tr>";
    		
    		
    		foreach ($customerListData['customerIdList'] as $Id) {
    			$sAmount = "";
    			$sAllCustomers .= "<tr>
    								<td class=productsbought>";
    			$sAllCustomers .= $Id;
    			$sAllCustomers .= "</td>
    								<td class=productsbought>";
    			
    			try {
    				//list all sessions for customer
    				$sessionListData = $dispatcher -> sessionList(MCP__ACCESSKEY, MCP__TESTMODE, $Id);
    			    
    				foreach ($sessionListData['sessionIdList'] as $list) {
    					$sessionData = $dispatcher -> sessionGet(MCP__ACCESSKEY, MCP__TESTMODE, $list);
    					
    					//only if session APPROVED or CHARGED
    					if (($sessionData['status'] == "APPROVED") || ($sessionData['status'] == "CHARGED")) {
	   						$sAllCustomers .= $sessionData['title']."<br />";
	   					} 
    					else {
    						$sAllCustomers .= "<em>keine Produkte</em><br />";
    					}

    					$sAmount .= formatAmount(($sessionData['amount'] / 100)). " ". PROJECT_CURRENCY. "<br />";
    				}
    				
    				//$sAmount = formatAmount(($sessionData['amount'] / 100)). " ". PROJECT_CURRENCY. "<br />";
    				$sAllCustomers .= "</td>";  
    				$sAllCustomers .= "<td class=productsbought>";
					$sAllCustomers .= $sAmount;
    				$sAllCustomers .= "</td>";
    				$sAllCustomers .= "</tr>";
    				
	   			} 
	   			catch(Exception $e) {
    				//no sessions available
    				$sAllCustomers .= "<em>". 'Keine Produkte vorhanden'. "</em></td>";
    				$sAllCustomers .= "<td  class=productsbought><em>-</em></td>";
    				$sAllCustomers .= "</tr>";
    			}
    		}
    		
    		$sAllCustomers .= "</table></div>";
    	}
    	catch (Exception $e) {
    		print $e->getMessage(); 
    		exit(0);
    	}
    	
    	//show buttons for next or previous x customers via AJAX
    	$sAllCustomers .= "<table width='100%'><tr><td width='50%' align=right>";
    	
    	if ($_SESSION['anchor'] > 0) {
    		$sAllCustomers .= "<div align=right class=productsbought>";
    		$sAllCustomers .= "<a href='#'
    	
									onClick=\"new Ajax.Updater('allCustomer', './debit_demo.php', 
									{
										method:'post',
										parameters: 'action=showAdminTools&anchor=-'+$showCustomer,
										onLoading: function() {
											document.getElementById('allCustomer').innerHTML = '<img src=./img/ajax-loader.gif>';
										},								
		  								onFailure: function() {
			  								alert('ERROR: Cannot send data. Please try again...');
		  								}
									}
									); return false;\"
    	
    							>&laquo;</a>";
    	}
    	$sAllCustomers .= "</td<td align=left width='50%' >";
    	
    	if (($_SESSION['anchor']+SHOW_CUSTOMER) < $customerListData['maxCount']) {

    		$sAllCustomers .= "<div align=right>";
    		$sAllCustomers .= "<a href='#'
    	
									onClick=\"new Ajax.Updater('allCustomer', './debit_demo.php', 
									{
										method:'post',
										parameters: 'action=showAdminTools&anchor=+'+$showCustomer,
										onLoading: function() {
											document.getElementById('allCustomer').innerHTML = '<img src=./img/ajax-loader.gif>';
										},								
		  								onFailure: function() {
			  								alert('ERROR: Cannot send data. Please try again...');
		  								}
									}
									); return false;\"
    	
    						>&raquo;</a>";
    	}
    	
    	$sAllCustomers .= "</td>
    					</tr>
    				</table>
    			</div>";
    	
		getTemplate('page.admintool.html', 'allCustomer', $sAllCustomers); 
		exit(0);
	}
//---------------------------------------------------------------------	

//---------------------------------------------------------------------
	if ($_GET['action'] == 'logout') {
		
		session_name('debit');
		session_start();
		
		if (1 == $_GET['shop']){
			getTemplate('shop.php'); 
			exit(0);
		}
		else {
			//unset session
			session_destroy(); 
			session_unset();
			
			getTemplate('page.login.html', 'radio', 'radio', 'customer_type', 'known', 'countproductsbought', '<b>(0)</b>', 'error_msg', 'Sie wurden erfolgreich ausgeloggt!'); 
			exit(0);
		}
	}
//---------------------------------------------------------------------

	else {
		//no GET/POST-variables -> link to demo-shop
		header("Location: index.php");
	}
//---------------------------------------------------------------------

?>